
proc mc:plimit {n uh h c t} {
  global mcs mc ct mcr mcc mce rnam

  if {[llength $t] > 1} {
    set ll [lindex [ms:fl $t] 1]
    if {[isnumber $ll]} {
      set mc(limit) $ll
    }
  }
  mc:tsay $n [format $ct(11b) $mc(limit)]
}

proc mc:startreg {} {
  global mc ct noreg

  putlog "REGSTART"
  set rand [rand 3]
  mc:say [mc:randchars $ct(reg$rand)]
  set noreg 0
  utimer 4 {
    if {$mc(moderating) == 1 && [mc:moderated]} {
      pushmode $mc(chan) -m
      #putquick "MODE $mc(chan) -m"
    }
  }
}

proc mc:pstartreg {n uh h c t} {
  global mc ct noreg

  putlog "!startreg"
  cleartimers
  set rand [rand 3]
  mc:say [mc:randchars $ct(reg$rand)]
  set noreg 0
  utimer 4 {
    if {$mc(moderating) == 1 && [mc:moderated]} {
      pushmode $mc(chan) -m
      #putquick "MODE $mc(chan) -m"
    }
  }
}

proc mc:preg {n uh h c t} {
    global mcs mc ct mcr mcc mce rnam noreg mco cto mctn
    set id [tolower [ms:fl $n]]
    if {$noreg == 1} { return }
    if {![mc:check $id 0]} { return }

    set ondcc 0
    foreach nn [array names mctn] {
        if {$mctn($nn) == $id} {
            set ondcc 1
        }
    }

    if {![info exists mcs($id)]} {
        mc:tsay $n $ct(10)
        return
    }

    set mcrstr ""
    set mctnstr ""
    foreach idr [array names mcr] { set mcrstr "$mcrstr $idr" }
    foreach idr [array names mctn] { set mctnstr "$mctnstr $idr" }
#    putlog "-----"
#    putlog "limit = |$mc(limit)| ondcc = |$ondcc|"
#    putlog "!REG BEF <$n>"
#    putlog "mcr   = |$mcrstr|"
#    putlog "mctn  = |$mctnstr|"
#    putlog "sof1  = |[llength $mcrstr]| sof2 = |[llength $mctnstr]|"
#    putlog "size1 = |[array size mcr]| size1 = |[array size mctn]|"

    if {[array exists mcr] && [info exists mcr($id)] && ([llength $t] == 1)} {
#        putquick "KICK $c $n
#        mc:tsay $n [format $ct(11) [mc:delcom $mcc($mcr($id))]]
        return
    } elseif {[array exists mcr] && [info exists mcr($id)] && (([array size mcr] < $mc(limit)) || ([info exist mcr($id)]))} {
        unset mcr($id)
        unset mce($id)
        if {[array size mcr] == 0} {
            unset mcr
            unset mce
            unset mcc
        } else {
            foreach e [array names mcr] {
                set ttmm($mcr($e)) 1
            }
            foreach e [array names mcc] {
                if {![info exists ttmm($e)]} {
                    unset mcc($e)
                }
            }
        }
    } elseif {[array exist mcr] && ([array size mcr] >= $mc(limit))} {
#        mc:tsay $n [format $ct(11a) $mc(limit)]
#        putlog "(ondcc == 0)"
        return
    } else {
        pushmode $mc(chan) +v $n
    }
    cleartimers
    set regcom ""
    if {[array exists mcc]} {
        set maxcom 1
        foreach nn [array names mcc] {
            if {[expr $nn + 1] > $maxcom} { set maxcom [expr $nn + 2] }
        }
        set mostcom 1
        for {set i 1} {$i <= $maxcom} {incr i} {
            if {![info exist mcc($i)]} {
                set mostcom $i
                break
            }
        }
    } else {
        set maxcom 1
        set mostcom 1
    }
    if {[llength $t] == 1} {
        if {[array exists mcc]} {
            foreach e [array names mcc] {
                if {[mc:comid [mc:modget $id 2]] == [mc:comid $mcc($e)]} {
                    set regcom $e
                    break
                }
            }
        }
        if {$regcom == ""} {
            set regcom $mostcom
        }
    } else {
        set tmpcom [lindex $t 1]
        if {[isnumber $tmpcom]} { set tmpcom [expr round($tmpcom)] }
        if {(![isnumber $tmpcom]) || ($tmpcom > $maxcom) || ($tmpcom == 0)} {
            mc:tsay $n $ct(12)
            return
        }
        set regcom $tmpcom
    }
    set toreg ""
    if {([array exist mcc]) && ([info exist mcc($regcom)])} {
        set toreg $mcc($regcom)
    } elseif {[mc:modget $id 2] != "-"} {
        set toreg [mc:modget $id 2]
    }
    if {($toreg != "") && ([info exist mco([mc:comid $toreg])])} {
        set cid [mc:comid $toreg]
        set ac [mc:comga $cid $id]
        if {(([mc:mcomget $cid 4] == 1) && ($ac < 1)) || ($ac < 0)} {
            mc:tsay $n [format $cto(0a) [mc:mcomget $cid 0]]
            return
        }
    }
    if {(![array exists mcc]) || (([array exists mcc]) && (![info exists mcc($regcom)]))} {
        if {[mc:modget $id 2] != "-"} {
            set tmc [mc:modget $id 2]
            if {[info exist mco([mc:comid $tmc])]} {
                set tmc [mc:mcomget [mc:comid $tmc] 0]
            }
            set mcc($regcom) $tmc
        } else {
            set mcc($regcom) ".$regcom"
        }
    }

    if {[mc:modget $id 41] == ""} { set mcs($id) [linsert $mcs($id) end " "] }
    if {[mc:modget $id 42] == ""} { set mcs($id) [linsert $mcs($id) end " "] }
    if {[mc:modget $id 43] == ""} { set mcs($id) [linsert $mcs($id) end " "] }

    set mcr($id) $regcom
    set mce($id) 0

    #"12%s14\(10%s14/10%s 06l:%s14\) 10   14<%s14> 14\(10%s14\)"
    #<><><>(</> l:<>)    <_> (<_>)

    set output ""

    # 
    if {$mc(sptitles) == 1 && ([mc:modget $id 43] != " " && ([mc:modget $id 17] >= 5))} {
        set output "$output10[mc:modget $id 43] "
    }
    set output "$output12$n"

    # 
    if {$mc(stitles) == 1 && ([mc:modget $id 42] != " " && ([mc:modget $id 17] >= 5))} {
        set output "$output10[mc:modget $id 42] "
    }
    set output "$output14\("

    # /
    if {$mc(sraces) == 1 && [mc:modget $id 41] != " " && ([mc:modget $id 17] >= 5)} {
        set output "$output[mc:modget $id 41]"
    } else {
        set output "$output10$rnam([mc:modget $id 16])14/10$rnam([mc:modget $id 15])"
    }

#    set output "$output 06l:[mc:modget $id 17]14\) 10   14< [mc:delcom [ms:dfl $mcc($regcom)]] 14> \(10$regcom14\)"
    set output [xformat3 $ct(14a) "[mc:modget $id 21]" $output [mc:modget $id 17] [mc:delcom [ms:dfl $mcc($regcom)]] $regcom]

    mc:say $output

    set mcrstr ""
    set mctnstr ""
    foreach idr [array names mcr] { set mcrstr "$mcrstr $idr" }
    foreach idr [array names mctn] { set mctnstr "$mctnstr $idr" }
#    putlog "-----"
#    putlog "!REG AFT <$n>"
#    putlog "mcr   = |$mcrstr|"
#    putlog "mctn  = |$mctnstr|"
#    putlog "sof1  = |[llength $mcrstr]| sof2 = |[llength $mctnstr]|"
#    putlog "size1 = |[array size mcr]| size1 = |[array size mctn]|"

    if {[array size mcr] >= $mc(limit)} {
#        putlog "0,4FULL LIMIT"
        mc:say [format $ct(11a) $mc(limit)]
    }
}

proc mc:punreg {n uh h c t} {
  global mcs mc ct mcr mcc mce
  if {$mc(phase) != 0} {return}
  set id [tolower [ms:fl $n]]

  if {![info exists mcs($id)]} {
    mc:tsay $n $ct(10)
    return
  }
  if {[array exists mcr] && [info exists mcr($id)]} {
    mc:tsay $n [format $ct(14) [mc:delcom [ms:dfl $mcc($mcr($id))]]]
    pushmode $mc(chan) -v $n
    unset mcr($id)
    unset mce($id)
    if {[array size mcr] == 0} {
      unset mcr
      unset mce
      unset mcc
    } else {
      foreach e [array names mcr] {
        set ttmm($mcr($e)) 1
      }
      foreach e [array names mcc] {
        if {![info exists ttmm($e)]} {
          unset mcc($e)
        }
      }
    }
  }
}

proc mc:pcom {n uh h c t} {
  global mcs mc ct mcr mcc mce lastcom

  if {$mc(phase) < 1} {
    mc:pcom1 $n $uh $h $c $t
  } elseif {$mc(phase) != 0} {
    mc:pcom2 $n $uh $h $c $t
  } else {
    return
  }
}

#  
proc mc:pcom1 {n uh h c t} {
  global mcs mc ct mcr mcc mce lastcom
  if {$mc(phase) != 0} { return }

  if {[info exist lastcom] && ($lastcom > [clock seconds])} {
     return
  }
  if {[array exists mcr]} {
    foreach e [array names mcr] {
      if {$mce($e)} {
        set tmpnick "[mc:nick $e]"
      } else {
        set tmpnick "[mc:nick $e]"
      }
      if {[info exists ttmm($mcr($e))]} {
        set ttmm($mcr($e)) [lappend ttmm($mcr($e)) $tmpnick]
      } else {
        set ttmm($mcr($e)) $tmpnick
      }
    }
    set coms "12:"
    foreach e [array names ttmm] {
      set nextteam [join $ttmm($e) ", "]
      set nexttname [mc:delcom [string trimright $mcc($e) 10]]
      if {[expr [string length $coms]+[string length $nextteam]+[string length $nexttname]] > 380} {
        mc:say $coms
        set coms "12:"
      }
      #set coms "$coms [ms:dfl "06$e.14\[[mc:delcom [string trimright $mcc($e) 10]]14\]10 [join $ttmm($e) "14,10 "]\;"]"
      set coms "$coms [ms:dfl "06$e.14\[$nexttname14\]10 $nextteam\;"]"
    }
    mc:say $coms
  } else {
    mc:tsay $n $ct(16)
  }
  set lastcom [expr [clock seconds] + 30]
}

#   
proc mc:pcom2 {n uh h c t} {
  global mcs mc ct mcr mcc mce liv nnick prc lastcom
  if {$mc(phase) < 1} { return }

  if {[info exist lastcom] && ($lastcom > [clock seconds])} {
    return
  }
  if {[array exists liv]} {
    foreach e [array names liv] {
      if {($prc($e) == 0) && ($mc(phase) == 1)} {
        set tmpnick "$nnick($e)"
      } else {
        set tmpnick "$nnick($e)"
      }
      if {[info exists ttmm($mcr($e))]} {
        set ttmm($mcr($e)) [lappend ttmm($mcr($e)) $tmpnick]
      } else {
        set ttmm($mcr($e)) $tmpnick
      }
    }
    set coms "12:"
    foreach e [array names ttmm] {
      set nextteam [join $ttmm($e) ", "]
      set nexttname [mc:delcom [string trimright $mcc($e) 10]]
      if {[expr [string length $coms]+[string length $nextteam]+[string length $nexttname]] > 390} {
        mc:say $coms
        set coms "12:"
      }
      #set coms "$coms [ms:dfl "14\[[mc:delcom [string trimright $mcc($e) 10]]14\]10 [join $ttmm($e) "14,10 "]\; "]"
      set coms "$coms [ms:dfl "14\[$nexttname14\]10 $nextteam\;"]"
    }
    mc:say $coms
  } else {
    mc:tsay $n $ct(16)
  }
  set lastcom [expr [clock seconds] + 60]
}

proc mc:pmoves {n uh h c t} {
  global mcs mc ct mcr mcc mce lastcom

  if {$mc(phase) < 1} {
    mc:pmoves1 $n $uh $h $c $t
  } elseif {$mc(phase) != 0} {
    mc:pmoves2 $n $uh $h $c $t
  } else {
    return
  }
}

#  
proc mc:pmoves1 {n uh h c t} {
  global mcs mc ct mcr mcc mce liv nnick prc lastmoves

  if {[info exist lastmoves] && ($lastmoves > [clock seconds])} { return }

  if {[array exists mcr]} {
    foreach e [array names mcr] {
      set tmpnick ""
      if {!$mce($e)} { set tmpnick "[mc:nick $e]" }
      if {[info exists ttmm($mcr($e))]} {
        set ttmm($mcr($e)) [join [lappend ttmm($mcr($e)) $tmpnick]]
      } else {
        set ttmm($mcr($e)) $tmpnick
      }
    }
    set coms "12 :"
    foreach e [array names ttmm] {
      set nextteam [join $ttmm($e) ", "]
      set nexttname [mc:delcom [string trimright $mcc($e) 10]]
      if {[expr [string length $coms]+[string length $nextteam]+[string length $nexttname]] > 390} {
        mc:say $coms
        set coms "12 :"
      }
      if {$ttmm($e) != ""} {
        #set coms "$coms [ms:dfl "06$e.14\[[mc:delcom [string trimright $mcc($e) 10]]14\]10 [join $ttmm($e) ", "]\;"]"
        set coms "$coms [ms:dfl "06$e.14\[$nexttname14\]10 $nextteam\;"]"
      }
    }
    if {[llength $coms] >= 3} { mc:say $coms
    } else { mc:say "10    ." }
  } else {
    mc:tsay $n $ct(16)
  }
  set lastmoves [expr [clock seconds] + 30]
}

#   
proc mc:pmoves2 {n uh h c t} {
  global mcs mc ct mcr mcc mce liv nnick prc lastmoves

  if {[info exist lastmoves] && ($lastmoves > [clock seconds])} { return }

  if {[array exists liv]} {
    foreach e [array names liv] {
      set tmpnick ""
      if {($prc($e) != 0) && ($mc(phase) == 1)} { set tmpnick "$nnick($e)" }
      if {[info exists ttmm($mcr($e))]} {
        set ttmm($mcr($e)) [join [lappend ttmm($mcr($e)) $tmpnick]]
        #set ttmm($mcr($e)) "$ttmm($mcr($e)), $tmpnick"
      } else {
        set ttmm($mcr($e)) $tmpnick
      }
    }
    set coms "12 :"
    foreach e [array names ttmm] {
      set nextteam [join $ttmm($e) ", "]
      set nexttname [mc:delcom [string trimright $mcc($e) 10]]
      if {[expr [string length $coms]+[string length $nextteam]+[string length $nexttname]] > 390} {
        mc:say $coms
        set coms "12 :"
      }
      if {$ttmm($e) != ""} {
        #set coms "$coms [ms:dfl "14\[[mc:delcom [string trimright $mcc($e) 10]]14\]10 [join $ttmm($e) ", "]\; "]"
        set coms "$coms [ms:dfl "14\[$nexttname14\]10 $nextteam\; "]"
      }
    }
    if {[llength $coms] >= 3} { mc:say $coms
    } else { mc:say "10   ." }
  } else {
    mc:tsay $n $ct(16)
  }
  set lastmoves [expr [clock seconds] + 30]
}

proc mc:pname {n uh h c t} {
  global mcs mc ct mcr mcc mce
  if {$mc(phase) != 0} { return }
  set id [tolower [ms:fl $n]]

  if {[llength $t] < 2} { return }
  if {[array exists mcr] && [info exists mcr($id)]} {
    set tcomm "[mc:delcom [lrange [ms:fl $t] 1 end]]10"
    mc:say [format $ct(13a) $mcr($id) [mc:delcom [ms:dfl $mcc($mcr($id))]] [ms:dfl $tcomm]]
    set mcc($mcr($id)) $tcomm
  } else {
    mc:tsay $n $ct(15)
  }
}

proc mc:pready {n uh h c t} {
  global mcs mc ct mcr mcc mce

  if {$mc(phase) != 0} { return }
  set id [tolower [ms:fl $n]]

  if {![array exists mcr] || ![info exists mcr($id)]} {
    mc:tsay $n $ct(15)
    return
  }
  if {$mce($id)} { return }
  cleartimers
  set mce($id) 1
  mc:say [xformat3 $ct(17) "[mc:modget $id 21]" $n]
  mc:checkcomm
}

proc mc:punready {n uh h c t} {
  global mcs mc ct mcr mcc mce

  if {$mc(phase) != 0} { return }
  set id [tolower [ms:fl $n]]

  if {![array exists mcr] || ![info exists mcr($id)]} {
    mc:tsay $n $ct(15)
    return
  }
  if {$mce($id)} {
    cleartimers
    set mce($id) 0
    mc:say [xformat3 $ct(17b) "[mc:modget $id 21]" $n]
    mc:checkcomm
  }
}

proc mc:pclear {n uh h c t} {
  global mcs mc ct mcr mcc mce

  if {$mc(phase) != 0} { return }
  if {[array exists mcc]} { unset mcc }
  if {[array exists mcr]} { unset mcr }
  if {[array exists mce]} { unset mce }
}

proc mc:checkcomm {} {
  global mcs mc ct mcr mcc mce
  if {$mc(phase) != 0} { return }

  if {(![array exists mce]) || ([array size mce] < 2)} {
    mc:say $ct(18a)
    return
  }
  foreach e [array names mce] {
    if {!$mce($e)} {
#      mc:say $ct(18)
      utimer 30 { mc:checkcomm }
      return
    }
  }
  cleartimers
  set comm(0) 0
  set allcom 0
  foreach cc [array names mcr] {
    if {[info exist comm($mcr($cc))]} {
      incr comm($mcr($cc)) [mc:modget $cc 17]
    } else {
      set comm($mcr($cc)) [mc:modget $cc 17]
    }
    incr allcom [mc:modget $cc 17]
  }
  foreach cc [array names comm] {
    if {$comm($cc) > [expr $allcom - $comm($cc)]} {
      mc:say [format $ct(18b) [mc:delcom $mcc($cc)]]
      utimer 30 { mc:checkcomm }
      return
    }
  }
  utimer 30 { mc:pstart n uh h c t }
}

proc mc:pstart {n uh h c t} {
  global mcs mc ct mcr mcc mce min ts tl ti tm tv th ta tg te todo liv param nnick prc hitten countr countt localfavor listact

  if {[array exists liv]} { unset liv }
  if {[array exists ghost]} { unset ghost }
  cleartimers
  mc:say $ct(19)

  #if {$mc(moderating) == 1 && ![mc:moderated]} {
  #  #pushmode $mc(chan) +m
  #  putquick "MODE $mc(chan) +m"
  #}
  mc:checkvoices

  set mc(phase) 1
  if {[array size mcr] > 10} {
    set mc(flags) ""
    putlog "setting slow mode"
  } else {
    set mc(flags) "F"
    putlog "setting fast mode"
  }

  if {[array exists localfavor]} { unset localfavor }
  if {[array exists listact]}    { unset listact }

  set countr 0
  set countt [unixtime]

  foreach e [array names mcr] {
    set localfavor($e) 0
    set listact($e) ""
  # 
    set ts($e) [mc:modget $e 4]
  # 
    set tl($e) [mc:modget $e 5]
  # 
    set ti($e) [mc:modget $e 7]
  # 
    set tm($e) [mc:modget $e 6]
  # 
    set tv($e) [mc:modget $e 8]
    foreach pr [mc:modget $e 13] {
       set addd [mc:wget [lindex $pr 1] plushark $e]
       if {([llength $addd]>1)&&([lindex $pr 2])} {
          #putlog "add@$e![lindex $pr 1]!$addd"
          set ts($e) [expr $ts($e) + [lindex $addd 0]]
          set tl($e) [expr $tl($e) + [lindex $addd 1]]
          set ti($e) [expr $ti($e) + [lindex $addd 2]]
          set tm($e) [expr $tm($e) + [lindex $addd 3]]
          set tv($e) [expr $tv($e) + [lindex $addd 4]]
       }
    }
  # 
  #!!
    set th($e) [expr [mc:modget $e 10] + 1.0 * $tv($e) / 3]
#    set th($e) 0
  # 
    set ta($e) [expr $tm($e) * 1.5]
  # 
    set tg($e) 0
  # 
  #!!
    set te($e) 0
#    set te($e) 40000
  # ------------
  #  
    set todo($e) ""
  #   
    set prc($e) 100
  #  ?
    set liv($e) 1
  #  " "
    set param($e) ""
    set nnick($e) [mc:nick $e]
  }
  set hitten 0
  mc:start
}
