# ASLL
   proc mc:harksok {wid id} {
      global thi
      if { [info exist thi($wid)]} {
         set ps [mc:modget $id 4]
         set pl [mc:modget $id 5]
         set pm [mc:modget $id 6]
         set pi [mc:modget $id 7]
         set pv [mc:modget $id 8]
         set harks [mc:wget $wid hark]
         set mins 0
         set minl 0
         set minm 0
         set mini 0
         set minv 0
         set deps 1
         set depl 1
         set depm 1
         set depi 1
         set depv 1
#         putlog "mharks:$harks"
         if { [llength $harks]>0 } { set mins [lindex $harks 0] }
         if { [llength $harks]>1 } { set minl [lindex $harks 1] }
         if { [llength $harks]>2 } { set minm [lindex $harks 2] }
         if { [llength $harks]>3 } { set mini [lindex $harks 3] }
         if { [llength $harks]>4 } { set minv [lindex $harks 4] }
#         putlog "min:$mins, str=$ps"
         if { $ps < $mins } { return -1 }
#         putlog "min:$minl, str=$pl"
         if { $pl < $minl } { return -1 }
#         putlog "min:$minm, str=$pm"
         if { $pm < $minm } { return -1 }
#         putlog "min:$mini, str=$pi"
         if { $pi < $mini } { return -1 }
#         putlog "min:$minv, str=$pv"
         if { $pv < $minv } { return -1 }
         set harks [mc:wget $wid harkdeps]
#         putlog "harks:$harks"
#         if { [llength $harks]>0 } { set deps [lindex $harks 0] }
         if { [llength $harks]>1 } { set depl [lindex $harks 1] }
         if { [llength $harks]>2 } { set depm [lindex $harks 2] }
         if { [llength $harks]>3 } { set depi [lindex $harks 3] }
         if { [llength $harks]>4 } { set depv [lindex $harks 4] }
#         putlog "harks:$deps:$depl:$depm:$depi:$depv"
         set sdep [expr 1 + ( $ps - $mins ) / $deps]
         set ldep [expr 1 + ( $pl - $minl ) / $depl]
         set mdep [expr 1 + ( $pm - $minm ) / $depm]
         set idep [expr 1 + ( $pi - $mini ) / $depi]
         set vdep [expr 1 + ( $pv - $minv ) / $depv]
         return [expr $sdep * $ldep * $mdep * $idep * $vdep]
      }
      return -1
   }
set prof(p) {     3 3 5 5 9 5 120  0 0 0 0 2 4 4000.0 }
set prof(m) {      3 4 5 9 4 5 110  0 0 0 1 1 4 4000.0 }
set prof(w) {     9 4 6 3 3 7 100  2 0 0 0 0 4 4000.0 }
set prof(l) {   ? ? ? ? ? ? 110  0 1 1 0 0 4 4000.0 }
set prof(y) {  3 3 7 7 5 6 110  0 0 1 1 0 4 4000.0 }
# :  reg harks   gold lev harks f _
