
listen 4321 script mc:tel
listen 4322 script mc:ttel

#  
proc mc:tel {idx} {
   global mctn mctp mcnt
   control $idx mc:telnet
   set mctn($idx) ""
   set mctp($idx) ""
}

#   !dcc
proc mc:ttel {idx} {
   global mctn mctp mcnt nick
   control $idx mc:telnet
   set mctn($idx) ""
   set mctp($idx) ""
   putidx $idx "Nickname?\r"
}

proc mc:telnet {idx arg} {
    global mctn mctp mcs mcnt nick

    if {[lindex [ms:fl $arg] 0] == "USER"} { return }

    if {$arg == ""} {
        putlog "TLN !$idx! closed !$mctn($idx)!"
        unset mctn($idx)
        unset mctp($idx)
        return
    }
    #  
    if {$mctn($idx) == ""} {
        if {[lindex [ms:fl $arg] 0] == "100"} {
            #     
            putidx $idx "101 $nick"
            set id [tolower [lindex [ms:fl $arg] 1]]
        } else {
            #     !dcc
            set id [tolower [lindex [ms:fl $arg] 0]]
        }
        putlog "\(telnet\[$mctn($idx)/$idx\]\) TRY IDENT NICK: [lindex [ms:fl $arg] end]"
        if {[info exist mcs($id)]} {
            set mctn($idx) $id
            set mcnt($id) $idx
            putidx $idx "Password?\r"
            putlog "TLN: !$idx! - try password..."
        } else {
            putlog "TLN: !$idx! - bad nick !$arg!"
            putidx $idx "No such nick."
            killdcc $idx
            unset mctn($idx)
            unset mctp($idx)
        }
        return
    }
    #  
    if {$mctp($idx) == ""} {
        set id $mctn($idx)
        if {[mc:modget $id 1] == $arg} {
            set mctp($idx) $arg
            putidx $idx "You are logged.\r"
            putlog "TLN: !$idx!$id! - loged!"
        } else {
            putlog "TLN: !$idx!$id! - killed! pass - !$arg!"
            putidx $idx "Bad password."
            killdcc $idx
            unset mcnt($mctn($idx))
            unset mctn($idx)
            unset mctp($idx)
        }
        return
    }
    putlog "\(telnet\[$mctn($idx)/$idx\]\) $arg"
    foreach ee [binds "*mc:*"] {
        if {([lindex $ee 0] == "msgm") && ([lindex $ee 1] == "-|-")} {
            if {[string match -nocase [lindex $ee 2] [stripspec $arg]]} {
                eval "[lindex $ee 4] {[stripspec [ms:dfl [mc:modget $mctn($idx) 0]]]} {telnet@telnet} {nohandle} {[stripspec $arg]}"
            }
        }
    }
}

bind dcc m adcc     mc_arenadcc
bind dcc m killadcc mc_killarenadcc

proc mc_arenadcc {h i a} {
    global mc mctn mctp

    set addc "IDX\(%d\) %-20s - IDLE: %4dsec - %s"

    putlog "Arena DCC-List:"
    foreach id [array names mctn] {
        set logged "04Not logged"
        if {$mctp($id) != ""} { set logged "Logged" }
        putlog "[format $addc $id $mctn($id) [getdccidle $id] $logged]"
    }
    putlog "End of DCC-List"
    putlog "Use .killadcc to kill \"04Not logged\" users."
}

proc mc_killarenadcc {h i a} {
    global mc mcnt mctn mctp

    putlog "Kill \"Not logged\" connections."
    foreach id [array names mctn] {
        if {$mctp($id) == ""} {
            unset mcnt($mctn($id))
            unset mctn($id)
            unset mctp($id)
            killdcc $id
        }
    }
}
